Apache Commons Net 3.13.0 Release Notes
---------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.13.0.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


This is a feature and maintenance release. Java 8 or later is required.

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi


New features
------------

o           Add DatagramSocketClient.getDefaultTimeoutDuration() and deprecate getDefaultTimeout(). Thanks to Gary Gregory.
o NET-741:  Add subnet IPv6 handling with SubnetUtils6 #391. Thanks to Maros Orsak, Gary Gregory.

Fixed Bugs
----------

o           DaytimeTCPClientTest now should now pass inside most VPNs. Thanks to Henri Biestro, Gary Gregory.
o           Migrate tests to JUnit5 #358, #359. Thanks to Jakub Kupczyk, Gary Gregory.
o           Fix malformed Javadoc comments. Thanks to Gary Gregory.
o           IMAPExportMbox now restores the current thread's interrupt flag when catching InterruptedException. Thanks to Gary Gregory.
o           IOUtil.readWrite() now restores the current thread's interrupt flag when catching InterruptedException. Thanks to Gary Gregory.
o           TelnetInputStream now restores the current thread's interrupt flag when catching InterruptedException. Thanks to Gary Gregory.
o NET-740:  FTP fails to parse listings for Linux vsftpd in Chinese or Japanese #393. Thanks to Jianwei Guo, Gary Gregory.
o           TelnetInputStream.read() doesn't preserve the original InterruptedException as the cause of its InterruptedIOException. Thanks to Gary Gregory.
o           FTPClient._storeFile(String, String, InputStream) doesn't always close it's internal socket when an exception is thrown early in processing. Thanks to Gary Gregory.
o           ListenerList.removeListener(T) now ignores null input to avoid a NullPointerException. Thanks to Gary Gregory.
o           ListenerList.addListener(T) now ignores null input. Thanks to Gary Gregory.
o           Fix typo in FTPConnectionClosedException message from FTP.getReply(boolean). Thanks to Gary Gregory.
o           Reimplement Util.copyReader() with IOUtils.copyLarge(). Thanks to Gary Gregory.
o           Reimplement Util.copyStream() with IOUtils.copyLarge(). Thanks to Gary Gregory.
o           Reimplement Util.copyStream() with IOUtils.copyLarge(). Thanks to Gary Gregory.
o           Deprecate Util.copyReader(Reader, Writer) in favor of IOUtils.copyLarge(Reader, Writer). Thanks to Gary Gregory.

Changes
-------

o           Bump org.apache.commons:commons-parent from 85 to 97 #371, #388, #389. Thanks to Gary Gregory, Dependabot.
o           Bump org.apache.commons:commons-lang3 from 3.18.0 to 3.19.0. Thanks to Gary Gregory, Dependabot.
o           Bump commons-io:commons-io from 2.20.0 to 2.21.0. Thanks to Gary Gregory.
o           Bump Util.DEFAULT_COPY_BUFFER_SIZE from 1 KiB to 8 KiB. Thanks to Gary Gregory.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.12.0 Release Notes
---------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.12.0.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.

This is a feature and maintenance release. Java 8 or later is required.

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi


New features
------------

o           Add org.apache.commons.net.nntp.Article#getChild(). Thanks to Gary Gregory.
o           Add org.apache.commons.net.nntp.Article#getNext(). Thanks to Gary Gregory.
o           Add private SubnetAddressStringIterable and private SubnetAddressStringIterator to implement SubnetInfo.iterableAddressStrings() and SubnetInfo.streamAddressStrings() #298. Thanks to Lixiongyou, Gary Gregory.
o           Add SubnetInfo.iterableAddressStrings(). Thanks to Gary Gregory.
o           Add SubnetInfo.streamAddressStrings(). Thanks to Gary Gregory.
o           Add FTPCmd.OPTS. Thanks to Gary Gregory.
o           Add FTP.opts(String, String). Thanks to Gary Gregory.
o           Add FTP.opts(String...). Thanks to Gary Gregory.
o           Add FTP.setControlEncoding(Charset). Thanks to Gary Gregory.
o           Add --OPTS to FTPClientExample. Thanks to Gary Gregory.
o NET-727:  Add accessing options map for TFTP request packet and allow using 'blksize' option #331. Thanks to Gary Gregory.
o           Add org.apache.commons.net.util.ListenerList.isEmpty(). Thanks to Gary Gregory.
o           Add org.apache.commons.net.ftp.FTPClient.getSystemTypeOverride(). Thanks to Gary Gregory.
o           Add generics to ListenerList. Thanks to Gary Gregory.
o           Add module-info.class in the JAR file instead of an Automatic-Module-Name in MANIFEST.MF. Thanks to Gary Gregory.

Fixed Bugs
----------

o           Increase message limit in IMAPReply.TAGGED_RESPONSE from 80 to 500 characters. Thanks to Andreas Lemke, Gary Gregory.
o           Increase message limit in IMAPReply.UNTAGGED_RESPONSE from 160 to 500 characters. Thanks to Andreas Lemke, Gary Gregory.
o           Remove InvalidKeySpecException from AuthenticatingIMAPClient.auth(AUTH_METHOD, String, String) never throws, it's not thrown. Thanks to Gary Gregory.
o           Remove InvalidKeySpecException from AuthenticatingIMAPClient.authenticate(AUTH_METHOD, String, String) never throws, it's not thrown. Thanks to Gary Gregory.
o           Remove InvalidKeySpecException from ExtendedPOP3Client.auth(AUTH_METHOD, String, String) never throws, it's not thrown. Thanks to Gary Gregory.
o           Remove InvalidKeySpecException from org.apache.commons.net.smtp.AuthenticatingSMTPClient.auth(AUTH_METHOD, String, String) never throws, it's not thrown. Thanks to Gary Gregory.
o           Fix SpotBugs RCN_REDUNDANT_NULLCHECK_OF_NONNULL_VALUE in SSLSocketUtils. Thanks to Gary Gregory.
o           Fix PMD UnnecessaryFullyQualifiedName. Thanks to Gary Gregory.
o           Fix PMD UnusedFormalParameter. Thanks to Gary Gregory.
o           Fix PMD AvoidBranchingStatementAsLastInLoop in org.apache.commons.net.bsd.RCommandClient. Thanks to Gary Gregory.
o           Fix PMD UselessOverridingMethod in org.apache.commons.net.telnet.TelnetClient. Thanks to Gary Gregory.
o           Fix PMD UnnecessaryModifier. Thanks to Gary Gregory.
o           Deprecate MLSxEntryParser default constructor in favor of MLSxEntryParser.getInstance(). Thanks to Gary Gregory.
o           Deprecate direct access to org.apache.commons.net.nntp.Article.kid and next fields. Thanks to Gary Gregory.
o           Fix SpotBugs CT_CONSTRUCTOR_THROW in Base64 by implementing finalize() as a noop to avoid finalizer attacks. Thanks to Gary Gregory.
o           Add missing Javadoc to ListenerList. Thanks to Gary Gregory.
o           Add missing Javadoc to SubnetUtils. Thanks to Gary Gregory.
o           Deprecate PrintCommandListeners.PrintCommandListeners(). Thanks to Gary Gregory.
o           Deprecate NtpUtils.NtpUtils(). Thanks to Gary Gregory.
o           Deprecate FTPFileFilters.FTPFileFilters(). Thanks to Gary Gregory.
o           Avoid multiple possible NullPointerException in SocketClient.verifyRemote(Socket). Thanks to Gary Gregory.
o           PrintCommandListener.protocolReplyReceived(ProtocolCommandEvent) doesn't always use an end-of-line. Thanks to Gary Gregory.
o           FTPClientExample uses the wrong FTP system type to parse file lines. Thanks to Gary Gregory.
o           Base64 does not call super.finalize(). Thanks to Gary Gregory.
o           TFTPServer does not call super.finalize(). Thanks to Gary Gregory.
o           KeyManagerUtils.loadStore(String, File, String) shouldn't ignore an IOException closing a keystore stream; use try-with-resources. Thanks to Gary Gregory.
o           NNTPClient.readNewsgroupListing() can use an ArrayList instead of a Vector. Thanks to Gary Gregory.
o           Deprecate org.apache.commons.net.util.Charsets. Thanks to Gary Gregory.
o           Performance: NTFTPEntryParser.parseFTPEntry(String) doesn't need to parse timestamps if there is no name. Thanks to Gary Gregory.
o           Improve error handling in org.apache.commons.net.ftp.parser.DefaultFTPFileEntryParserFactory.createFileEntryParser(String, FTPClientConfig). Thanks to Gary Gregory.
o           Fail-fast in org.apache.commons.net.PrintCommandListener.PrintCommandListener(PrintWriter, boolean, char, boolean) if the PrintWriter is null. Thanks to Gary Gregory.
o           Avoid NullPointerException in org.apache.commons.net.PrintCommandListener.org.apache.commons.net.PrintCommandListener.protocolCommandSent(ProtocolCommandEvent). Thanks to Gary Gregory.
o           Avoid NullPointerException in org.apache.commons.net.PrintCommandListener.org.apache.commons.net.PrintCommandListener.protocolReplyReceived(ProtocolCommandEvent). Thanks to Gary Gregory.

Changes
-------

o           Bump org.apache.commons:commons-parent from 70 to 85 #261, #278, #280, #285, #298, #293, #300, #345. Thanks to Gary Gregory, Dependabot.
o           Bump org.apache.commons:commons-lang3 from 3.14.0 to 3.18.0 #268, #273, #281, #354. Thanks to Gary Gregory, Dependabot.
o           Bump commons-io:commons-io from 2.16.1 to 2.20.0 #286, #308. Thanks to Gary Gregory, Dependabot.
o           Bump org.apache.commons:commons-collections4 from 4.5.0-M2 to 4.5.0 #314. Thanks to Gary Gregory, Dependabot.
o           Bump org.apache.ftpserver:ftpserver-core from 1.2.0 to 1.2.1. Thanks to Gary Gregory.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.11.1 Release Notes
---------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.11.1.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


This is a feature and maintenance release. Java 8 or later is required.

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi


Fixed Bugs
----------

o           Allow longer data in pattern IMAPReply.UNTAGGED_RESPONSE. Thanks to Stuart Maclean, Gary Gregory.
o           Fix Reproducible Builds issues #259. Thanks to Hervé Boutemy, Gary Gregory.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.11.0 Release Notes
---------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.11.0.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


Maintenance and bug fix release (Java 8 or above).

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi

New features
------------

o NET-726:  Add protected getters to FTPSClient #204. Thanks to PJ Fanning, Gary Gregory.
o           Add SubnetUtils.toString(). Thanks to Gary Gregory.
o           Add Maven property project.build.outputTimestamp for build reproducibility. Thanks to Gary Gregory.
o           Add FTP.DEFLATE_TRANSFER_MODE to support the "deflate" compression format in FTPClient.setFileTransferMode(int). Thanks to Georg Voss, Gary Gregory.
o           Add org.apache.commons.net.SocketClient.checkOpenOutputStream(). Thanks to Gary Gregory.

Fixed Bugs
----------

o           Precompile regular expression in UnixFTPEntryParser.preParse(List<String>). Thanks to Gary Gregory.
o           Guard against polynomial regular expression used on uncontrolled data in VMSVersioningFTPEntryParser.REGEX. Thanks to Gary Gregory.
o           Guard against polynomial regular expression used on uncontrolled data in IMAPReply.TAGGED_RESPONSE. Thanks to Gary Gregory.
o           Guard against polynomial regular expression used on uncontrolled data in IMAPReply.UNTAGGED_RESPONSE. Thanks to Gary Gregory.
o NET-730:  Cannot connect to FTP server with HTTP proxy. Thanks to Johannes Thalmair, Gary Gregory.
o           Base 64 Encoding with URL and Filename Safe Alphabet should not chunk per RFC 4648. Thanks to Gary Gregory.
o           Deprecate org.apache.commons.net.util.Charsets.Charsets() for removal. Thanks to Gary Gregory.
o           Deprecate org.apache.commons.net.util.TrustManagerUtils.TrustManagerUtils() for removal. Thanks to Gary Gregory.

Changes
-------

o           Bump commons-parent from 62 to 70 #238. Thanks to Dependabot, Gary Gregory.
o           Bump org.codehaus.mojo:exec-maven-plugin from 3.1.0 to 3.2.0, #221. Thanks to Dependabot.
o           Bump commons-lang3 from 3.13.0 to 3.14.0. Thanks to Gary Gregory.
o           Bump commons-io from 2.15.0 to 2.16.1 #236, #240. Thanks to Gary Gregory.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes-report.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.10.0 Release Notes
---------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.10.0.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


Maintenance and bug fix release (Java 8 or above).

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi

New features
------------

o           Add and use DatagramSocketClient.setDefaultTimeout(Duration) and deprecate DatagramSocketClient.setDefaultTimeout(int). Thanks to Gary Gregory.
o           Add and use TFTP.DEFAULT_TIMEOUT_DURATION and deprecate org.apache.commons.net.tftp.TFTP.DEFAULT_TIMEOUT. Thanks to Gary Gregory.
o           Add and use DatagramSocketClient#getSoTimeoutDuration(). Thanks to Gary Gregory.
o           Add and use DatagramSocketClient#setSoTimeout(Duration). Thanks to Gary Gregory.
o           Add and use DatagramSocketClient.checkOpen(). Thanks to Gary Gregory.
o           Add TelnetClient.sendAYT(Duration). Thanks to Gary Gregory.
o           TFTPServer implements AutoCloseable. Thanks to Gary Gregory.
o           DatagramSocketClient implements AutoCloseable. Thanks to Gary Gregory.
o           Add IMAP package tests, include junit-jupiter-params artifact #166. Thanks to KuKa, Gary Gregory.
o           Add Base64 missing tests and documentation fixes #161. Thanks to KuKa, Bruno P. Kinoshita.
o           Add FTPFile tests and fix Javadoc typos #162. Thanks to KuKa, Gary Gregory.
o           Add IMAPReply tests and documentation fixes #165. Thanks to KuKa, Gary Gregory, Bruno P. Kinoshita.

Fixed Bugs
----------

o NET-650:  Delegate host resolution to Socket.connect() #138. Thanks to Matthew McGillis, exceptionfactory, sebbASF.
o           Fixes many grammar issues and typos in JavaDoc and code comments #141. Thanks to Martin Wiesner, Gary Gregory, sebbASF.
o           Remove redundant (null) initializations and other clean ups #155. Thanks to Martin Wiesner, Gary Gregory.
o           TFTPServer.setMaxTimeoutRetries() now throws IllegalArgumentException instead of RuntimeException. Thanks to Gary Gregory.
o           TFTPServer.setSocketTimeout() now throws IllegalArgumentException instead of RuntimeException. Thanks to Gary Gregory.
o           FTPCommand.checkArray() now throws IllegalStateException instead of RuntimeException. Thanks to Gary Gregory.
o           org.apache.commons.net.nntp.Threader now throws IllegalStateException instead of RuntimeException. Thanks to Gary Gregory.
o           POP3Command static initializer now throws IllegalStateException instead of RuntimeException. Thanks to Gary Gregory.
o           SMTPCommand static initializer now throws IllegalStateException instead of RuntimeException. Thanks to Gary Gregory.
o           SubnetUtils.SubnetInfo.getPreviousAddress() now throws IllegalStateException instead of RuntimeException. Thanks to Gary Gregory.
o           IMAPExportMbox.MboxListener.chunkReceived(IMAP) now throws UncheckedIOException instead of RuntimeException. Thanks to Gary Gregory.
o           IMAPUtils.imapLogin(URI, int, ProtocolCommandListener) now throws IOException instead of RuntimeException while maintaining method signature source compatibility. Thanks to Gary Gregory.
o           [StepSecurity] ci: Harden GitHub Actions #156. Thanks to step-security-bot, Gary Gregory.
o NET-722:  Javadoc for FtpClient.setControlKeepAliveReplyTimeout(Duration) says timeout is in milliseconds. Thanks to David Costanzo, Gary Gregory.
o           Change class org.apache.commons.net.ftp.parser.MVSFTPEntryParser to support more datasets #182. Thanks to haegar9766, Gary Gregory.
o           Bulletproof TFTPServerPathTest #173. Thanks to Jakub Kupczyk, Bruno P. Kinoshita, Gary Gregory.
o           Deprecate org.apache.commons.net.util.Base64 in favor of java.util.Base64. Thanks to Gary Gregory.
o           Replace use of org.apache.commons.net.util.Base64 with java.util.Base64 in org.apache.commons.net.ftp. Thanks to Gary Gregory.
o           Replace use of org.apache.commons.net.util.Base64 with java.util.Base64 in org.apache.commons.net.imap. Thanks to Gary Gregory.
o           Replace use of org.apache.commons.net.util.Base64 with java.util.Base64 in org.apache.commons.net.pop3. Thanks to Gary Gregory.
o           Replace use of org.apache.commons.net.util.Base64 with java.util.Base64 in org.apache.commons.net.smtp. Thanks to Gary Gregory.

Changes
-------

o           Bump commons-parent from 54 to 62 #132, #137, #153. Thanks to Dependabot.
o           Bump commons-io from 2.11.0 to 2.14.0. Thanks to Gary Gregory.
o           Bump commons-lang3 from 3.12.0 to 3.13.0. Thanks to Gary Gregory.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes-report.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.9.0 Release Notes
--------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.9.0.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


Maintenance and bug fix release (Java 8 or above).

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi

New features
------------

o           [FTP] Add FTPClient.mdtmInstant(String). Thanks to Gary Gregory.
o           [FTP] Add MLSxEntryParser.parseGmtInstant(String). Thanks to Gary Gregory.
o           [FTP] Add FTPClient.getControlKeepAliveReplyTimeoutDuration(). Thanks to Gary Gregory.
o           [FTP] Add FTPClient.setControlKeepAliveReplyTimeout(Duration). Thanks to Gary Gregory.
o           [FTP] Add FTPClient.getControlKeepAliveTimeoutDuration(). Thanks to Gary Gregory.
o           [FTP] Add FTPClient.setControlKeepAliveTimeout(Duration). Thanks to Gary Gregory.
o           [FTP] Add FTPClient.getDataTimeout(). Thanks to Gary Gregory.
o           [FTP] Add FTPClient.setDataTimeout(Duration). Thanks to Gary Gregory.
o           [FTP] Add FTPFile.getTimestampInstant(). Thanks to Gary Gregory.
o           Add github/codeql-action. Thanks to Gary Gregory.

Fixed Bugs
----------

o NET-708:  Use yyyy instead of YYYY in SimpleDateFormat #97. Thanks to XenoAmess.
o           Prevent serialization of the 4 classes that implement Serializable.
            It is not useful and is unlikely to work properly.
o           Use Math.min and Math.max method instead of manual calculations. #104. Thanks to Arturo Bernal.
o NET-711:  Add FTP option to toggle use of return host like CURL. Thanks to Jochen Wiedmann, Gary Gregory.
o NET-642:  FTPSClient execPROT removes proxy settings #90. Thanks to Yani Mihaylov, Gary Gregory.
o           JUnit5 assertThrows SimpleSMTPHeaderTestCase #121. Thanks to John Patrick, Gary Gregory.
o           JUnit5 assertThrows TestTimeInfo #120. Thanks to John Patrick, Gary Gregory.
o           Simplify conditions avoiding extra operations #88. Thanks to Arturo Bernal, Gary Gregory.
o           Remove reflection from SSLSocketUtils. Thanks to Gary Gregory.
o NET-707:  Process files with spaces in name for OS400 #95. Thanks to Dmytro Sylaiev, sebbASF, Gary Gregory.

Changes
-------

o           Bump actions/cache from 2.1.6 to 3.0.11 #93, #102, #115, #116. Thanks to Dependabot, Gary Gregory.
o           Bump actions/checkout from 2.3.4 to 3.1.0 #89, #91, #100, #114. Thanks to Dependabot, Gary Gregory.
o           Bump actions/upload-artifact from 3.1.0 to 3.1.1 #124. Thanks to Dependabot.
o           Bump junit from 4.13.1 to 5.9.1 Vintage #74. Thanks to Dependabot.
o           Bump commons-io from 2.6 to 2.11.0 #60. Thanks to Dependabot, Gary Gregory.
o           Bump commons.jacoco.version from 0.8.6 to 0.8.8. Thanks to Gary Gregory.
o           Bump commons.japicmp.version from 0.14.3 to 0.17.1. Thanks to Gary Gregory.
o           Bump commons.surefire.version from 2.22.2 to 3.0.0-M7. Thanks to Gary Gregory.
o           Bump ftpserver-core from 1.1.1 to 1.2.0 #96. Thanks to XenoAmess, Gary Gregory.
o           Bump exec-maven-plugin from 3.0.0 to 3.1.0 #109. Thanks to Dependabot.
o           Bump commons-parent from 53 to 54 #112. Thanks to Dependabot.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes-report.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.8.0 Release Notes
--------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.8.0.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


Maintenance and bug fix release (Java 7 or above).

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi

New features
------------

o           Add and use NetConstants. Thanks to Arturo Bernal, Gary Gregory.
o           Add and use SocketClient.applySocketAttributes(). Thanks to Gary Gregory.
o           Add FTPClient.hasFeature(FTPCmd). Thanks to Gary Gregory.
o           Add FTPClient.mdtmCalendar(String). Thanks to Gary Gregory.

Fixed Bugs
----------

o           Fix concurrent counting of chunks in IMAPExportMbox. Thanks to Gary Gregory.
o           Fix possible if rare NPEs in tests. Thanks to Gary Gregory.

Changes
-------

o           Bump actions/checkout from v2.3.3 to v2.3.4 #69. Thanks to Dependabot.
o NET-685:  Update SocketClient default connect timeout from ? to 60 seconds #51. Thanks to Simo385.
o NET-695:  Apply SocketClient timeout after connection but before SSL negotiation. Thanks to Gary Gregory, Possibly Cott.
o           Minor Improvements #71, #72. Thanks to Arturo Bernal, Gary Gregory.
o           Bump actions/cache from v2 to v2.1.4 #73. Thanks to Dependabot.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes-report.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.7.2 Release Notes
--------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.7.2.

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


Maintenance and bug fix release.

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi

Fixed Bugs
----------

o NET-689:  Host name is not set on the SSLSocket causing isEndpointCheckingEnabled to fail. Thanks to Charlie, Gary Gregory.
o           Fix possible socket and input stream leak on socket exception in org.apache.commons.net.ftp.FTPClient._retrieveFile(String, String, OutputStream). Thanks to Dependabot.
o NET-690:  Performance issue when using the FTPClient to retrieve files #65. Thanks to payal-meh, Gary Gregory.

Changes
-------

o NET-691:  Improve Javadoc for IMAPSClient #68. Thanks to Lewis John McGibbney.
o           Bump actions/setup-java from v1.4.2 to v1.4.3 #62. Thanks to Dependabot.
o           Bump junit from 4.13 to 4.13.1 #67. Thanks to Dependabot.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes-report.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.7.1 Release Notes
--------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.7.1

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.


Maintenance and bug fix release.

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi

Fixed Bugs
----------

o NET-687:  [FTPS] javax.net.ssl.SSLException: Unsupported or unrecognized SSL message, #59. Thanks to Gary Gregory, Mikael, j-verse.
o NET-673:  Update actions/checkout from v2.3.1 to v2.3.3 #56, #61. Thanks to Dependabot.
o NET-673:  Update actions/setup-java from v1.4.0 to v1.4.2 #58. Thanks to Dependabot.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes-report.html

Enjoy!
-Apache Commons Net team

-----------------------------------------------------------------------------

Apache Commons Net 3.7 Release Notes
------------------------------------

The Apache Commons Net team is pleased to announce the release of Apache Commons Net 3.7

Apache Commons Net library contains a collection of network utilities and protocol implementations.
Supported protocols include Echo, Finger, FTP, NNTP, NTP, POP3(S), SMTP(S), Telnet, and Whois.

This is mainly a bug-fix release. See further details below.
 This release requires a minimum of Java 7.
 This release is binary compatible with previous releases.
However it is not source compatible with releases before 3.4, as some methods were added to the interface NtpV3Packet in 3.4
 Note that the examples packages were moved under org/apache/commons/net/examples.
The examples are not part of the public API, so this does not affect compatibility.

Changes in this version include:

New features
------------

o NET-646:  ALLO FTP Command for files >2GB
o NET-615:  IMAPClient could simplify using empty arguments
o NET-614:  IMAP fails to quote/encode mailbox names
o NET-648:  Add Automatic-Module-Name MANIFEST entry for Java 9 compatibility
o NET-638:  Telnet subnegotiations hard-limited to 512 bytes - allow override Thanks to Daniel Leong.
o NET-634:  Add SIZE command support Thanks to Mauro Molinari.
o           Add POP3ExportMbox example code
o NET-674:  FTPListParseEngine should support listing via MLSD Thanks to Chris Steingen.
o NET-660:  Next and Previous IP Address in SubnetUtils.SubnetInfo Thanks to Nagabhushan S N.

Fixed Bugs
----------

o NET-673:  IMAPClient.APPEND does not always calculate the correct length
o NET-643:  NPE when closing telnet stream Thanks to Vasily.
o NET-641:  SubnetUtils.SubnetInfo.isInRange("0.0.0.0") returns true for CIDR/31, 32 Thanks to pin_ptr.
o NET-639:  MVSFTPEntryParser.preParse - MVS, z/OS - allow for merged Ext/Used fields Thanks to Alexander Eller.
o NET-636:  examples should be in org.apache.commons.net subpackage
o NET-631:  Bug in MVSFTPEntryParser.parseUnixList (FindBugs)
o NET-584:  Error when using org.apache.commons.net.ftp.FTPClient setControlKeepAliveTimeout Thanks to Kazantsev Andrey Sergeevich/Nick Manley.
o NET-624:  SubnetInfo#toCidrNotation: A wrong format subnet mask is allowed Thanks to Makoto Sakaguchi.
o NET-623:  SubnetUtils - fixed spelling errors Thanks to Makoto Sakaguchi.
o NET-613:  System Information Leak in ftp parser Thanks to Donald Kwakkel.
o NET-663:  NullPointerException when FTPClient remote verification fails Thanks to Max Shenfield.
o NET-649:  227 Entering Passive Mode Thanks to Filipe Bojikian Rissi.
o NET-682:  MVSFTPEntryParser doesn't support Record Formats of U Thanks to richard.

Changes
-------

o NET-633:  Add XOAUTH2 to IMAP and SMTP Thanks to n0rm1e.
o NET-632:  FTPHTTPClient - support for encoding other than UTF-8 Thanks to prakapenka.
o NET-626:  SubnetUtils#SubnetUtils - improved comment Thanks to Makoto Sakaguchi.
o NET-625:  SubnetUtils - improve construction
o NET-624:  SubnetInfo#getCidrSignature - improve functions Thanks to Makoto Sakaguchi.
o NET-621:  SubnetUtils#SubnetInfo - remove unnecessary accessors Thanks to Makoto Sakaguchi.
o NET-619:  SubnetUtils - improve binary netmask algorithm Thanks to Makoto Sakaguchi.
o NET-678:  VMS ftp LIST parsing results in empty file list Thanks to Roman Grigoriadi.


Historical list of changes: https://commons.apache.org/proper/commons-net/changes-report.html

For complete information on Apache Commons Net, including instructions on how to submit bug reports,
patches, or suggestions for improvement, see the Apache Commons Net website:

https://commons.apache.org/proper/commons-net/

Download page: https://commons.apache.org/proper/commons-net/download_net.cgi

-----------------------------------------------------------------------------
